@echo off
cls

echo Launching The Trickster's Loot Locator ...

setlocal ENABLEEXTENSIONS
@rem SETLOCAL ENABLEDELAYEDEXPANSION

@rem Set JRE_HOME in order to force a specific JRE, in case needed
@rem E.g: set to blank in order to ignore old/outdated environment variable and allow the latest version to be used instead
@rem set JRE_HOME=
@rem E.g: force a specific JRE to be used
@rem set JRE_HOME=C:\Program Files\Java\jre7

if NOT "%JRE_HOME%"=="" (
	if NOT EXIST "%JRE_HOME%\bin\java.exe" (
		echo JRE_HOME points to an invalid Java Runtime directory.
		goto END
	)

	goto ADDEXE
)

:: No JRE_HOME set, so detect JRE via Registry

:: Find current version of JRE matching OS (32/64bit)
set KEY_NAME="HKLM\SOFTWARE\JavaSoft\Java Runtime Environment"
FOR /F "usebackq skip=2 tokens=3" %%A IN (`REG QUERY %KEY_NAME% /v CurrentVersion 2^>nul`) DO (
	:: get the javahome for that version
	FOR /F "usebackq skip=2 tokens=3*" %%B IN (`REG QUERY %KEY_NAME%\%%A /v JavaHome 2^>nul`) DO (
		if "%%C" EQU "" (
			if EXIST "%%B\bin\java.exe" (
				set JRE=%%B
			)
		) else (
			if EXIST "%%B %%C\bin\java.exe" (
				set JRE=%%B %%C
			)
		)
	)
)

if defined JRE (
	goto FOUNDJRE
)

:: Find current version of 32bit JRE on 64bit OS
set KEY_NAME="HKLM\SOFTWARE\Wow6432Node\JavaSoft\Java Runtime Environment"
FOR /F "usebackq skip=2 tokens=3" %%A IN (`REG QUERY %KEY_NAME% /v CurrentVersion 2^>nul`) DO (
	:: get the javahome for that version
	FOR /F "usebackq skip=2 tokens=3*" %%B IN (`REG QUERY %KEY_NAME%\%%A /v JavaHome 2^>nul`) DO (
		if "%%C" EQU "" (
			if EXIST "%%B\bin\java.exe" (
				set JRE=%%B
			)
		) else (
			if EXIST "%%B %%C\bin\java.exe" (
				set JRE=%%B %%C
			)
		)
	)
)

if defined JRE (
	goto FOUNDJRE
) else (
    echo No valid JRE found in the Registry.
	echo (HKLM\SOFTWARE\JavaSoft\Java Runtime Environment)
	echo (HKLM\SOFTWARE\Wow6432Node\JavaSoft\Java Runtime Environment)
)

goto GETJRE

:FOUNDJRE

set JRE_HOME=%JRE%

:ADDEXE

echo Using JRE in %JRE_HOME%
set JAVA="%JRE_HOME%\bin\java.exe"

:DOCHECK

echo.
call %JRE_HOME%\bin\java -jar TTLL.jar %1 %2 %3 %4 %5 %6 %7 %8 %9
goto END

:GETJRE

echo.
echo It appears that no Java Runtime is installed and registered on your system.
echo Please obtain JRE 5.0 (or higher) from http://java.com or configure the path to the JRE in ttll.bat (see 'set JRE_HOME=' at the very top)
echo.

pause

:END
